#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "examine4xi.py">
#<abstract4xi abstract = "provides services to examine different versions of multiprocessing"/>
#<refer4xi reference = "yourDragon4Xi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# ------------------------------------------------------------------------------------------------- 
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'examine4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import time         
    from time import gmtime, strftime 
except:
    pass
try:                 # rare ones
    import datetime
except:
    pass 
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from timeouterror4xi import TimeoutError4Xi
from print4xi import print4xi
from time4xi import time4xi        
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global KB4Examination
global default2examine 
#"
#/> 


# -------------------------------------------------------------------------------------------------
# Settings to select multiprocessing for a class/method or for a function
#    True = use ORIGINAL multiprocessing, False = use multiprocessing4xi modules
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
KB4Examination = {
            'ArrayFunction4Xi2ArrayFunction4Xi': False,              # test_sharedctypes4xi.py
            
            'BoundedSemaphore4Xi2__init__': False,                   # __init__ of Queue4Xi for example
            'BoundedSemaphore4Xi2__repr__': False,
            
            'BufferWrapper4Xi2__init__': False,                      # test_sharedctypes4xi.py
            'BufferWrapper4Xi2get_address': False,
            'BufferWrapper4Xi2create_memoryview': False,
            'BufferWrapper4Xi2get_size': False,
            'BufferWrapper4Xi2create_memoryview': False,
            
            
            'Client4Xi2Client4Xi': False,                            # Client4Xi function
            
            'dump2dump': False,                                      # also embedded in Popen4Xi 
            
            'duplicate2duplicate': False,                            # test_resourcesharer4xi.py
            
            'DupFd4Xi2__init__': False,                              # test_resourcesharer4xi.py
            'DupFd4Xi2detach': False,                                # 
            
            'DupHandle4Xi2__init__': False,                          # test_resourcesharer4xi.py
            'DupHandle4Xi2detach': False,                            # 
            
            'DupSocket2__init__': False,                             # test_resourcesharer4xi.py
            'DupSocket2detach': False,                               #  

            'get_command_line2get_command_line': False,              # embedded in Popen4Xi                         
            'get_preparation_data4xi2get_preparation_data4xi': False,

            'freeze_support2freeze_support': False,                  # embedded in Popen4Xi 
             
            'Heap4Xi2__init__': False,                               # test_sharedctypes4xi.py
            'Heap4Xi2_roundup': False,
            'Heap4Xi2_malloc': False, 
            'Heap4Xi2_free': False, 
            'Heap4Xi2_absorb': False, 
            'Heap4Xi2_free_pending_blocks': False,
            'Heap4Xi2free': False,
            'Heap4Xi2malloc': False, 
                      
            'is_forking2is_forking': False,                          # embedded in Popen4Xi 
                                    
            'Listener4Xi2__init__': True,                            # test_resourcesharer4xi.py
            'Listener4Xi2accept': True,                              # 
            'Listener4Xi2close': True,                               #
            'Listener4Xi2__enter__': True,                           # 
            'Listener4Xi2__exit__': True,                            #   
            
            'Lock4Xi2__init__': False,                               # Lock4Xi
            'Lock4Xi2__repr__': False,

            'main2main': False,                                      # embedded in Popen4Xi  
                       
            'MainProcess4Xi2terminate': False,                       # MainProcess4Xi 
            'MainProcess4Xi2join': False,
            'MainProcess4Xi2is_alive': False,
            
                                              
            'Manager4Xi2Manager4Xi': True,                           # Manager4Xi function 

            'Pipe4Xi2Pipe4Xi': False,                                # Pipe4Xi function
            
            'PipeListener4Xi2__init__': True,                        # PipeConnection4Xi class
            'PipeListener4Xi2_new_handle': True,                     # PipeConnection4Xi class
            'PipeListener4Xi2accept': True,                          # PipeConnection4Xi class
            'PipeListener4Xi2_finalize_pipe_listener': True,         # PipeConnection4Xi class

            
            'Popen4Xi2__init__': False,                              # Popen4Xi
            'Popen4Xi2thread_is_spawning': False,
            'Popen4Xi2duplicate_for_child': False,
            'Popen4Xi2wait': False,
            'Popen4Xi2terminate': False, 
                                   
            'Process4Xi2__init__': False,                            # Process4Xi
            'Process4Xi2run': False,
            'Process4Xi2start': False, 
            'Process4Xi2terminate': False,
            'Process4Xi2join': False,
            'Process4Xi2is_alive': False,
            'Process4Xi2__repr__': False, 
            'Process4Xi2_bootstrap': False,
            
            'Queue4Xi2__init__': True,                               # original, otherwise test_verbkb4xi.py fails!
            'Queue4Xi2__getstate__': False,
            'Queue4Xi2__setstate__': False,
            'Queue4Xi2_after_fork': False,                           
            'Queue4Xi2put': False,
            'Queue4Xi2get': False,
            'Queue4Xi2join_thread': False,
            'Queue4Xi2cancel_join_thread': False,
            'Queue4Xi2_start_thread': False,
            'Queue4Xi2_finalize_join': False,
            'Queue4Xi2_finalize_close': True,                        # original, otherwise BrokenPipe Error in test_verbkb4xi.py!
            'Queue4Xi2_feed': False,
            
            'RawArray4Xi2RawArray4Xi': False,                        # test_sharedctypes4xi.py
            
            'ResourceSharer4Xi2__init__': True,                      # test_resourcesharer4xi.py
            'ResourceSharer4Xi2register': True,                      # 
            'ResourceSharer4Xi2get_connection': True,                # 
            'ResourceSharer4Xi2stop': True,                          # 
            'ResourceSharer4Xi2_afterfork': True,                    # 
            'ResourceSharer4Xi2_start': True,                        # 
            'ResourceSharer4Xi2_serve': True,                        # 
            
            'rebuild_ctype4xi2rebuild_ctype4xi': False,              # test_resourcesharer4xi.py 
            'reduce_ctype4xi2reduce_ctype4xi': False,                # test_resourcesharer4xi.py 
            
            'reduce_connection2reduce_connection': False,            # embedded in Popen4Xi 
            
            'RawValue4Xi2RawValue4Xi': False,
            'RLock4Xi2__init__': False,                              # Rock4Xi
            'RLock4Xi2__repr__': False,
            
            'SemLock4Xi2__init__': False,                            # SemLock4Xi 
            'SemLock4Xi2_make_methods': False,
            'SemLock4Xi2__getstate__': False,
            'SemLock4Xi2__setstate__': False,
            
            'Server4Xi2__init__': True,                              # Server4Xi
            'Server4Xi2serve_forever': True,
            'Server4Xi2handle_request': True,
            'Server4Xi2serve_client': True, 
            'Server4Xi2shutdown': True,
            'Server4Xi2create': True,
            'Server4Xi2accept_connection': True,
            'Server4Xi2incref': True, 
            'Server4Xi2decref': True,
             
            'synchronized_function4xi2synchronized_function4xi': False,  # test_sharedctypes4xi.py
                                                                      
            'SyncManager4Xi2__init__': True,                         # SyncManager4Xi
            'SyncManager4Xi2get_server': True,
            'SyncManager4Xi2connect': True,
            'SyncManager4Xi2start': True, 
            'SyncManager4Xi2_run_server': True,
            'SyncManager4Xi2_create': True,
            'SyncManager4Xi2join': True,
            'SyncManager4Xi2_debug_info': True,
            'SyncManager4Xi2_number_of_objects': True,
            'SyncManager4Xi2__enter__': True,
            'SyncManager4Xi2__exit__': True,
            'SyncManager4Xi2_finalize_manager': True, 
            'SyncManager4Xi2register': True, 

            'ValueFunction4Xi2ValueFunction4Xi': False,              # test_sharedctypes4xi.py
            'Value4Xi2__init__': False,
            'Value4Xi2get': False, 
            'Value4Xi2set': False, 
            'Value4Xi2__repr__': False,      

            '_MainProcess4Xi2terminate': False,                      # current_process4xi
            '_MainProcess4Xi2join': False,
            '_MainProcess4Xi2is_alive': False,
            
            '_new_value4xi2_new_value4xi': False                     # test_sharedctypes4xi.py
            }
          
             
default2examine = True # False = we use do NOT use the original multiprocessing but the dragonized one! 
#"
#"/>
 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "examine4xi" usage = "
#   provides services to select the multiprocessing to be used for a class/method or for a function
#
# Examples:
#1)syncmanager4xi.py
#
#   SyncManager4Xi:                                                  
#       __init__
#           class2print = "SyncManager4Xi"                           # <-- class to trace
#           method2print = "__init__"                                # <-- method to trace
#        
#           message2print = "{(Step 1/14a) started" + "; init-of-SyncManager4Xi-started: " + time4xi() + "}" 
#           print4xi(class2print, method2print, message2print)       # <-- trace message
#
#           if examine4xi(class2print, method2print):                # <-- selection
#               SyncManager.__init__(self, hub, passport, force)  #<-- original multiprocessing method called
#           else:
#               ...
#
#2)manager4xi.py
#
#   Manager4Xi:                                                      <-- special function starting with upper case
#
#       class2print = "Manager4Xi"                                   <-- for tracing
#       method2print = "Manager4Xi"                                  <-- for tracing
        
#       message2print = "{(Step 1/5a) started" + "; Manager4Xi-started: " + str(Manager4Xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)            
#     
#       if examine4xi(class2print, method2print):                    <-- you can use the same two parameters
#           message2print = "{(StepOriginal) returning" + "; Manager-function-returning-by-Manager4Xi: " + str(Manager) + "; time: " + time4xi() + "}" 
#           print4xi(class2print, method2print, message2print) 
#                
#           return Manager()                                         #<-- original multiprocessing function is used
#       else:
#           ....
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def examine4xi (class2examine, method2examine):
    '''
    returns multiprocessing to be used for a class/method or for a function
    '''
    global KB4Examination
    global default2examine 
       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
         
    class2print = 'examine4xi'
    method2print = 'examine4xi'
    
    message2print = "{started" + "; examine4xi-started: " + str(examine4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function examine4xi at 0x02BE3D68>; time: 01:11:13 04/13/10 Pacific Daylight Time}
       
    message2print = "{passed" + "; class2examine-passed-to-examine4xi: " + str(class2examine) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # Process4Xi
        
    message2print = "{passed" + "; method2examine-passed-to-examine4xi: " + str(method2examine) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # __init__                
       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
               
    keys2KB = KB4Examination.keys()
   
    key2caller = str(class2examine) + "2" + str(method2examine)

    message2print = "{set" + "; key2caller-set-by-examine4xi to: " + str(key2caller)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # Process4Xi2__init__        
        
    examination2xi = default2examine
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    for key2xi in sorted(keys2KB):
        if key2xi == key2caller:
            examination2xi = KB4Examination[key2caller]
            
            message2print = "{selected" + "; examination2xi-selected-by-examine4xi: " + str(examination2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
            # True
                    
            break
        else:
            pass
               

                       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    message2print = "{returning" + "; examination2xi-returning-by-examine4xi: " + str(examination2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   

    return examination2xi              
        
        
    
#</function4xi>
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#  test_hello_world4xi.txt
#  sense-hello-world4xi.xml
#  reason-hello-world4xi.xml
#  ace-hello-world4xi.xml

# test_proxy_mp_xi4.txt
# sense-proxy-mp-test4xi.xml
# reason-proxy-mp-test4xi.xml
# ace-proxy-mp-test4xi.xml
# 1. by setting all to True = use orinal multiprocessing, did NOT work, forking.py 339 failed
#
# 2. by setting Manager4Xi context ones, the following profile worked:
# KB4Examination = {'Manager4Xi2Manager4Xi': True,                    # Manager4Xi function 
#             'SyncManager4Xi2__init__': True,                        # SyncManager4Xi
#             'SyncManager4Xi2get_server': True,
#             'SyncManager4Xi2connect': True,
#             'SyncManager4Xi2start': True, 
#             'SyncManager4Xi2_run_server': True,
#             'SyncManager4Xi2_create': True,
#             'SyncManager4Xi2join': True,
#             'SyncManager4Xi2_debug_info': True,
#             'SyncManager4Xi2_number_of_objects': True,
#             'SyncManager4Xi2__enter__': True,
#             'SyncManager4Xi2__exit__': True,
#             'SyncManager4Xi2_finalize_manager': True, 
#             'SyncManager4Xi2register': True, 
#             'Process4Xi2__init__': False,                            # Process4Xi
#             'Process4Xi2run': False,
#             'Process4Xi2start': False, 
#             'Process4Xi2terminate': False,
#             'Process4Xi2join': False,
#             'Process4Xi2is_alive': False,
#             'Process4Xi2__repr__': False, 
#             'Process4Xi2_bootstrap': False,
#             'Client4Xi2Client4Xi': True,                            # Client4Xi function
#             '_MainProcess4Xi2terminate': False,                      # current_process4xi
#             '_MainProcess4Xi2join': False,
#             '_MainProcess4Xi2is_alive': False,
#             'get_preparation_data4xi2get_preparation_data4xi': False,
#             'Listener4Xi2__init__': True,                           # Listener4Xi
#             'Listener4Xi2accept': True, 
#             'Listener4Xi2close': True,
#             'Lock4Xi2__init__': False,                               # Lock4Xi
#             'Lock4Xi2__repr__': False,
#             'MainProcess4Xi2terminate': False,                       # MainProcess4Xi 
#             'MainProcess4Xi2join': False,
#             'MainProcess4Xi2is_alive': False,
#             'Pipe4Xi2Pipe4Xi': False,                                # Pipe4Xi function
#             
#             'dump2dump': False,                                      # embedded in Popen4Xi 
#             'duplicate2duplicate': False,                            # embedded in Popen4Xi 
#             'Popen4Xi2__init__': False,                              # Popen4Xi
#             'Popen4Xi2thread_is_spawning': False,
#             'Popen4Xi2duplicate_for_child': False,
#             'Popen4Xi2wait': False,
#             'Popen4Xi2terminate': False,
#             'is_forking2is_forking': False,                          # embedded in Popen4Xi 
#             'freeze_support2freeze_support': False,                  # embedded in Popen4Xi 
#             'get_command_line2get_command_line': False,              # embedded in Popen4Xi 
#             'main2main': False,                                      # embedded in Popen4Xi 
#             'reduce_connection2reduce_connection': False,            # embedded in Popen4Xi 
#             'Queue4Xi2__init__': False,                              # Queue4Xi
#             'Queue4Xi2__getstate__': False,
#             'Queue4Xi2__setstate__': False,
#             'Queue4Xi2_after_fork': False,
#             'Queue4Xi2put': False, 
#             'Queue4Xi2get': False,
#             'Queue4Xi2join_thread': False,
#             'Queue4Xi2cancel_join_thread': False,
#             'Queue4Xi2_start_thread': False,
#             'Queue4Xi2_finalize_join': False,
#             'Queue4Xi2_finalize_close': False,
#             'Queue4Xi2_feed': False,
#             'SemLock4Xi2__init__': False,                            # SemLock4Xi 
#             'SemLock4Xi2_make_methods': False,
#             'SemLock4Xi2__getstate__': False,
#             'SemLock4Xi2__setstate__': False,
#             'Server4Xi2__init__': True,                             # Server4Xi
#             'Server4Xi2serve_forever': True,
#             'Server4Xi2handle_request': True,
#             'Server4Xi2serve_client': True, 
#             'Server4Xi2shutdown': True,
#             'Server4Xi2create': True,
#             'Server4Xi2accept_connection': True,
#             'Server4Xi2incref': True, 
#             'Server4Xi2decref': True}
          



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of examine4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
